unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, EdTool, ExtCtrls,  Buttons, Mask, MydateEd,ListUnit;

type MyObject=class  {simple object with a date field}
 private
  FDate: TDateTime;
 public
  constructor Create(aDate:TDateTime);
  property TheDate:TDateTime read FDate write FDate;
end;

type TMyListSorted=Class(TListSorted)  {derived from TListSorted}
 function Compare(Item1, Item2: Pointer): Integer; override;
end;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    Memo1: TMemo;
    MyDateEdit: TMyDateEd;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  TheList: TMyListSorted;

implementation


{$R *.DFM}

constructor MyObject.Create(aDate:TDateTime);
begin
 Inherited Create;
 TheDate:=aDate;
end;

function TMyListSorted.Compare(item1,item2:Pointer):integer;
begin
 if MyObject(item1).Thedate <  MyObject(item2).Thedate  then Result:=-1;
 if MyObject(item1).Thedate =  MyObject(item2).Thedate  then Result:=0;
 if MyObject(item1).Thedate >  MyObject(item2).Thedate  then Result:=1;
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
var i:integer;
begin
 if TheList = nil then Exit;
 For i:=0 to Thelist.count-1 do
  MyObject(TheList.Items[i]).free;
 TheList.Free;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
   TheList:=TMyListSorted.Create;
end;

procedure TForm1.Button2Click(Sender: TObject);
var i:integer;
begin
   if TheList <> nil then begin
    TheList.Add(MyObject.Create(MyDateEdit.date));
    Memo1.Lines.Clear;
    For i:=0 to Thelist.count-1 do
      memo1.Lines.Add(dateToStr(MyObject(TheList.Items[i]).Fdate));
    end;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
 case( upcase(ShortDateFormat[1]) ) of
  'Y': ShortDateFormat:='yyyy'+DateSeparator+'mm'+DateSeparator+'dd';
  'M': ShortDateFormat:='mm'+DateSeparator+'dd'+DateSeparator+'yyyy';
  else ShortDateFormat:='dd'+DateSeparator+'mm'+DateSeparator+'yyyy';
  end; 
end;

end.
